/*
        SDTraffic v1.0 by Corneliu Cotofana (corneliu.valentin@gmail.com) (c) 2004
        
		This application is free software; you can redistribute it and/or
        modify it under the terms of the GNU Library General Public
        License as published by the Free Software Foundation; either
        version 2 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Library General Public License for more details.

        You should have received a copy of the GNU Library General Public
        License along with this library; if not, write to the
        Free Software Foundation, Inc., 59 Temple Place - Suite 330,
        Boston, MA  02111-1307  USA.
*/

package trafficcheck;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.Vector;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.ImageItem;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;
import javax.microedition.lcdui.ItemStateListener;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextBox;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

/*
 * Created on Aug 3, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Khyron 
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates 
 */
public class SDTraffic extends MIDlet implements CommandListener, ItemStateListener, ItemCommandListener {
	
    private static String trafficImageURLStr = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/sdmap/sdmap.gif" ;
    private static String queryFreewayIconURL = "/resources/QFIcon.png" ;
    private static String getMapIconURL = "/resources/GMIcon.png" ;
	private static String queryFreewayButtonLabelStr = "Query Freeway" ;
	private static String imageURL = "/resources/sdmap.gif" ;
	private static String getMapButtonLabelStr = "Get Live Map" ;
    private static String menuTitle = "SD Traffic" ;
    private static String queryFreewayFormTitle = "Query Freeway" ;
    private static String freewaysChoiceGroupTitle = "Pick a Freeway" ;
    private static String headingsChoiceGroupTitle = "Direction" ;
	private static String queryFreewayGoButtonLabel = " Go ! " ;
	private static String freewayStatusFormTitle = "Freeway Status" ;
	private static String freewayStatusTopLabel = "Trouble Spots:\n" ;
	
	private static String FREEWAY_5_NORTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/nb5.php" ;
	private static String FREEWAY_5_SOUTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/sb5.php" ;
	private static String FREEWAY_15_NORTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/nb15.php" ;
	private static String FREEWAY_15_SOUTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/sb15.php" ;
	private static String FREEWAY_8_EAST_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/eb8.php" ;
	private static String FREEWAY_8_WEST_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/wb8.php" ;
	private static String FREEWAY_805_NORTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/nb805.php" ;
	private static String FREEWAY_805_SOUTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/sb805.php" ;
	private static String FREEWAY_163_NORTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/nb163.php" ;
	private static String FREEWAY_163_SOUTH_URL = "http://www.dot.ca.gov/dist11/d11tmc/sdmap/speeds/sb163.php" ;
	
	private static String aboutString = "SDTraffic v1.0 by Corneliu Cotofana (corneliu.valentin@gmail.com) (c) 2004" ;
	
	private static int FREEWAY_5 = 0 ;
	private static int FREEWAY_805 = 1 ;
	private static int FREEWAY_8 = 2 ;
	private static int FREEWAY_15 = 3 ;
	private static int FREEWAY_163 = 4 ;
	
	private static int HEADING_NORTH = 0 ;
	private static int HEADING_SOUTH = 1 ;
	private static int HEADING_EAST = 2 ;
	private static int HEADING_WEST = 3 ;
	
	private static int RED_SPEED_TYPE = 0 ;
	private static int YELLOW_SPEED_TYPE = 1 ;
	
    
	
	private String errMsg = "" ;
    private Image trafficImage = null ;
	private boolean error = false ;
	private String errorString = null ;
    
	private Image getMapIcon ;
	private Image queryFreewayIcon ;
    private List list ;
    private List menuList ;
    private Command exit ;
    private Command aboutCommand ;
    private Command getMapCommand ;
    private Command queryFreewayCommand ;
    private Command doMenuListCommand ;
    private Command backToMainMenuCommand ;
    private Display display ; 
    private Form queryFreewayForm ;
    private TextBox textBox ;
	private StringItem getMapButtonStringItem ;

	private StringItem queryFreewayButtonStringItem ;
    private MyCanvas canvas ;
    private ChoiceGroup freewaysChoiceGroup ;
    private ChoiceGroup headingsChoiceGroup ;
	private Form freewayStatusForm;
	
	private Font redTypeFont ;
	private Font yellowTypeFont ;

	private Command backToQueryFreewayFormCommand;

	
	/**
	 * Initial Setup
	 */
	public SDTraffic() {

        display = Display.getDisplay( this ) ;

        // Set stuff up for main screen
        exit = new Command( "Exit", Command.EXIT, 1 ) ;
        getMapCommand = new Command( "Get Map", Command.SCREEN, 1 ) ;
        queryFreewayCommand = new Command( "Query Freeway", Command.SCREEN, 1 ) ;
        doMenuListCommand = new Command( "Do Menu List", Command.ITEM, 1 ) ;
        aboutCommand = new Command( "About", Command.ITEM, 1 ) ;
        
        String[] menuLabels = { getMapButtonLabelStr, queryFreewayButtonLabelStr } ;
        
        
        try{
        	getMapIcon = Image.createImage( getMapIconURL ) ;
        	queryFreewayIcon = Image.createImage( queryFreewayIconURL ) ;
        }
        catch( Exception e ) {
        	error = true ;
        	errorString = e.toString() ;
        }
    
        Image[] menuIcons = { getMapIcon, queryFreewayIcon } ;
        
        menuList = new List( menuTitle, List.IMPLICIT, menuLabels, menuIcons ) ;
        menuList.setSelectCommand( doMenuListCommand  ) ;
        menuList.addCommand( aboutCommand ) ;
        menuList.addCommand( exit ) ;
        menuList.setCommandListener( this ) ;
        
        // Set stuff up for Query Freeway Screen
        backToMainMenuCommand = new Command( "Main Menu", Command.SCREEN, 1 ) ;
        
        queryFreewayForm = new Form( queryFreewayFormTitle ) ;
        queryFreewayForm.addCommand( exit ) ;
        queryFreewayForm.addCommand( backToMainMenuCommand ) ;
        queryFreewayForm.setCommandListener( this ) ;
        
        freewaysChoiceGroup = new ChoiceGroup( freewaysChoiceGroupTitle, ChoiceGroup.POPUP ) ;
        freewaysChoiceGroup.append( "5", null ) ;
        freewaysChoiceGroup.append( "805", null ) ;
        freewaysChoiceGroup.append( "8", null ) ;
        freewaysChoiceGroup.append( "15", null ) ;
        freewaysChoiceGroup.append( "163", null ) ;
        freewaysChoiceGroup.setSelectedIndex( FREEWAY_5, true ) ;
        
        queryFreewayForm.append( freewaysChoiceGroup ) ;
        
        headingsChoiceGroup = new ChoiceGroup( headingsChoiceGroupTitle, ChoiceGroup.POPUP ) ;
        headingsChoiceGroup.append( "North", null ) ;
        headingsChoiceGroup.append( "South", null ) ;
        headingsChoiceGroup.append( "East", null ) ;
        headingsChoiceGroup.append( "West", null ) ;
        headingsChoiceGroup.setSelectedIndex( HEADING_SOUTH, true ) ;
        
        queryFreewayForm.append( headingsChoiceGroup ) ;
        
        queryFreewayButtonStringItem = new StringItem( queryFreewayGoButtonLabel, null, Item.BUTTON ) ;
        queryFreewayButtonStringItem.setDefaultCommand( queryFreewayCommand ) ;
        queryFreewayButtonStringItem.setItemCommandListener( this ) ;
        queryFreewayForm.append( queryFreewayButtonStringItem ) ;
        
        // Set up stuff for Query Freeway Results Screen
        backToQueryFreewayFormCommand = new Command( "Back", Command.SCREEN, 1 ) ;
        
        freewayStatusForm = new Form( freewayStatusFormTitle ) ;
        freewayStatusForm.addCommand( exit ) ;
        freewayStatusForm.addCommand( backToQueryFreewayFormCommand ) ;
        freewayStatusForm.addCommand( backToMainMenuCommand ) ;
        freewayStatusForm.setCommandListener( this ) ;

        redTypeFont = Font.getFont( Font.FACE_SYSTEM, Font.STYLE_ITALIC, Font.SIZE_SMALL ) ;
        yellowTypeFont = Font.getFont( Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL ) ;

	}
    
	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#startApp()
	 */
	protected void startApp() throws MIDletStateChangeException {
		display.setCurrent( menuList ) ;
	}

	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#pauseApp()
	 */
	protected void pauseApp() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.microedition.midlet.MIDlet#destroyApp(boolean)
	 */
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.microedition.lcdui.CommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Displayable)
	 */
	public void commandAction(Command command, Displayable displayable ) {

		try {
		
	        if( command == exit ) {
	            destroyApp( false ) ;
	            notifyDestroyed() ;
	        }
	        else if( command == doMenuListCommand ) {
	        	int selection = menuList.getSelectedIndex() ;
	        	// Download map Option
		        if( selection == 0 ) {
					// Don't retrieve if already have it
					// TODO: do a time comparison and only retrieve if map is X minutes old
					if( canvas == null ) {
						Image trafficImage = downloadImage( trafficImageURLStr ) ;
						canvas = new MyCanvas( this, trafficImage, "" ) ;
					}

					display.setCurrent( canvas ) ;
		        }
		        // Query Freeway Option
		        else if( selection == 1 ) {
		        	//printDebug( "Query Freeway" ) ;
		        	display.setCurrent( queryFreewayForm ) ;
		        }
	        }
	        else if( command == queryFreewayCommand ) {
	        	printDebug( "Query FFFFF ") ;
	        }
	        else if( command == backToMainMenuCommand  ) {
	        	//printDebug( "hi poop") ;
	        	showMenu() ;
	        }
	        else if( command == backToQueryFreewayFormCommand ) {
	        	display.setCurrent( queryFreewayForm ) ;
	        }
	        else if( command == aboutCommand ) {
	        	printDebug( aboutString ) ;
	        }
	        
		} catch( Exception e ) {
			printDebug( e.toString() ) ;
		}
	}
	


	private Image downloadImage( String URL ) {
		Image downloadedImage = null ;
		
		try {	
			InputStream inputStream = Connector.openInputStream( URL ) ;

			ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream() ;
			int ch ;
			while( (ch = inputStream.read() ) != -1 ) {
				byteArrayOutputStream.write( ch ) ;
			}
			
			byte imageArray[] = byteArrayOutputStream.toByteArray() ;
			
			// Create the image from the byte array
			downloadedImage = Image.createImage( imageArray, 0, imageArray.length ) ;
			
			ImageItem imageItem = new ImageItem( "label", trafficImage, Item.LAYOUT_CENTER, "alt text"  ) ;
			
		} catch( Exception e ) {
			printDebug( e.toString() ) ;			
		}	
		
		return downloadedImage ;
	}


    /**
     * Onboard debug routine
     * @param msg
     */
    public void printDebug( String msg ) {
        Alert alert = new Alert( "Debug", msg, null, null ) ;
        alert.setTimeout( Alert.FOREVER ) ;
        alert.setType( AlertType.CONFIRMATION ) ;
        display.setCurrent( alert ) ;
    }
    
	public void exitMIDlet() {
		try {
			destroyApp( true ) ;
			notifyDestroyed() ;
		}
		catch( Exception e ) {
			// TODO: handle this? 			
		}
	}
	
	/**
	 * 
	 */
	public void showMenu() {
		display.setCurrent( menuList ) ;
	}

	/* (non-Javadoc)
	 * @see javax.microedition.lcdui.ItemStateListener#itemStateChanged(javax.microedition.lcdui.Item)
	 */
	public void itemStateChanged( Item item ) {
		// TODO Auto-generated method stub		
	}

	/* (non-Javadoc)
	 * @see javax.microedition.lcdui.ItemCommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Item)
	 */
	public void commandAction(Command command, Item item) {
		// Query a freeway
		if( item == queryFreewayButtonStringItem ) {
			queryFreeway( freewaysChoiceGroup.getSelectedIndex(), headingsChoiceGroup.getSelectedIndex() ) ;		
		}
	}
	
	
	
	private void queryFreeway( int freeway, int heading ) {
		freewayStatusForm.deleteAll() ;
		
		String freewayURL = null ;
		String topLabel = "Fwy X Dir" ;
		if( (freeway == FREEWAY_5) && (heading == HEADING_NORTH) ) {
			freewayURL = FREEWAY_5_NORTH_URL  ;
			topLabel = "Fwy 5 North" ;
		}
		else if( (freeway == FREEWAY_5) && (heading == HEADING_SOUTH ) ) {
			freewayURL = FREEWAY_5_SOUTH_URL  ;
			topLabel = "Fwy 5 South" ;
		}
		else if( (freeway == FREEWAY_8) && (heading == HEADING_EAST ) ) {
			freewayURL = FREEWAY_8_EAST_URL  ;
			topLabel = "Fwy 8 East" ;
		}
		else if( (freeway == FREEWAY_8) && (heading == HEADING_WEST ) ) {
			freewayURL = FREEWAY_8_WEST_URL  ;
			topLabel = "Fwy 8 West" ;
		}
		else if( (freeway == FREEWAY_805) && (heading == HEADING_NORTH ) ) {
			freewayURL = FREEWAY_805_NORTH_URL  ;
			topLabel = "Fwy 805 North" ;
		}
		else if( (freeway == FREEWAY_805) && (heading == HEADING_SOUTH ) ) {
			freewayURL = FREEWAY_805_SOUTH_URL  ;
			topLabel = "Fwy 805 South" ;
		}
		else if( (freeway == FREEWAY_15) && (heading == HEADING_NORTH ) ) {
			freewayURL = FREEWAY_15_NORTH_URL  ;
			topLabel = "Fwy 15 North" ;
		}
		else if( (freeway == FREEWAY_15) && (heading == HEADING_SOUTH ) ) {
			freewayURL = FREEWAY_15_SOUTH_URL  ;
			topLabel = "Fwy 15 South" ;
		}
		else if( (freeway == FREEWAY_163) && (heading == HEADING_NORTH ) ) {
			freewayURL = FREEWAY_163_NORTH_URL  ;
			topLabel = "Fwy 163 North" ;
		}
		else if( (freeway == FREEWAY_163) && (heading == HEADING_SOUTH ) ) {
			freewayURL = FREEWAY_163_SOUTH_URL  ;
			topLabel = "Fwy 163 South" ;
		}
		else {
			printDebug( "Invalid Freeway/Direction Combination" ) ;
			return ;
		}
		
		// Set top label
		freewayStatusForm.setTitle( topLabel ) ;
		
		Vector troubleSpots = getFreewayTroubleSpots( freewayURL ) ;
		int currentItem = -1 ;
		int currentItemLength = -1 ;
		
		try {
		
			if( troubleSpots == null ) {
				printDebug( "Error retrieving results" ) ;
			}
			else {
				int vSize = troubleSpots.size() ;
				
				if( vSize == 0 ) {
					printDebug( "No delays on " + topLabel ) ;
					return ;
				}
				else {	
					freewayStatusForm.append( new StringItem( freewayStatusTopLabel, null, Item.PLAIN ) ) ;
					
					for( int i=0 ; i < vSize ; i++ ) {
						currentItem = i ;
						
						Object[] triplet = ( Object[] ) troubleSpots.elementAt(i) ;
						
						currentItemLength = triplet.length ;
						String str = (String) triplet[0] + ": " + (String) triplet[1] + "\n" ;
						StringItem troubleSpot = 
							new StringItem( null, str, Item.PLAIN ) ;
						if( ((Integer)triplet[2]).intValue() == RED_SPEED_TYPE ) {
							troubleSpot.setFont( redTypeFont ) ;
						}
						else {
							troubleSpot.setFont( yellowTypeFont ) ;
						}
						
						freewayStatusForm.append( troubleSpot ) ;
					}
				}
			}
		}
		catch( Exception e ) {
			String errStr = e.toString() + "CI=" + currentItem + ", CIL=" + currentItemLength ;
			printDebug( errStr ) ;
			
			freewayStatusForm.append( new StringItem( null, errStr, Item.PLAIN ) ) ;
		}
		
		display.setCurrent( freewayStatusForm ) ;

	}
	
	/**
	 * 
	 * @param freewayURL
	 * @return Vector of Object[] triplets... 
	 */
	Vector getFreewayTroubleSpots( String freewayURL ) {
		Vector troubleSpots = new Vector() ;
		
        StreamConnection connection = null ;
        InputStream in = null ;
        StringBuffer buffer = new StringBuffer() ;

        String color = "green" ;
        
        String pattern = "class=" ;
        String exitPattern = "class=menuitem" ;
        String noDataPattern = "no data" ;
        
        
        try {
            connection = (StreamConnection) Connector.open( freewayURL ) ;

            in = connection.openInputStream() ;
            int ch ;

        	String exitName = "EXIT" ;
            String speedInfo = "X mph" ;
            
            while( ( ch = in.read() ) != -1 ) {

                if( ch != '\n' ) {
                    buffer.append( (char) ch ) ;
                }
                else {  // Found newline; process the line

                    String generalLine = new String( buffer.toString() ) ;
                    int pos ;
                    
                    // Found the beginning of the data table
                    if( (pos = generalLine.indexOf( "LOCATION" ) ) != -1 ) {
                        
                    	buffer = new StringBuffer() ;
                        
                    	// Process data table
                        while( ( ch = in.read() ) != -1 ) {

                            if( ch != '\n' ) {
                                buffer.append( (char) ch ) ;
                            }
                            else {  // Found newline; process the line
                                                	
                                String line = new String( buffer.toString() ) ;
                                
                                int position ;                                                           
                                
                                if( (position = line.indexOf( pattern ) ) != -1 )  {
                                	int closeBracketIdx = line.indexOf( ">", position ) ;
                                	String itemType = line.substring( position + pattern.length(), closeBracketIdx ) ;
                                	
                                	// Exit name 
                                	if( itemType.equals( "menuitem") ) {
                                		int openBracketIdx = line.indexOf( "<", closeBracketIdx ) ;
                                		String potentialExitName = line.substring( closeBracketIdx + 1, openBracketIdx ) ;
                                	
//                                		<TD class=yellow>40 mph</TD></TR><TR><TD class=menuitem>Ted Williams Pkwy<BR></TD>
//										<TD class=menuitem>no data</TD></TR><TR><TD class=menuitem>Carmel Mountain Rd<BR></TD>
//										<TD class=menuitem>no data</TD></TR><TR><TD class=menuitem>Camino del Norte<BR></TD>
//										<TD class=yellow>40 mph</TD></TR><TR><TD class=menuitem>Bernardo Center Dr<BR></TD>
                                		
                                		
                                		// Beware of false match when there is no data for an exit
                                		if( ! potentialExitName.equals( noDataPattern ) ) {
                                			exitName = potentialExitName ;
                                		}
                                		else {
	                                		// Get Exit Name of next (which is on same line)
	                                		int menuItemIdx ;
	                                		if( (menuItemIdx = line.indexOf( exitPattern, openBracketIdx ) ) != -1 ) {
	                                			int endOfExitNameIdx = line.indexOf( "<", menuItemIdx ) ;
	                                			exitName = line.substring( menuItemIdx + exitPattern.length() + 1, endOfExitNameIdx ) ;
	                                		}
                                		}
                                	}
                                	// Speed 
                                	else {
                                		// Ignore green zones (no traffic)
                                		if( ! itemType.equals( "green" ) ) {
	                                			
                                			int speedType ;
                                			if( itemType.equals( "red" ) ) {
                                				speedType = RED_SPEED_TYPE ;
                                			}
                                			else {
                                				speedType = YELLOW_SPEED_TYPE ;
                                			}
                                			
	                                		// Grab speed
	                                		int openBracketIdx = line.indexOf( "<", closeBracketIdx ) ;
	                                		speedInfo = line.substring( closeBracketIdx + 1, openBracketIdx ) ;
	                                		
	                                		Object[] triplet = { exitName, speedInfo, new Integer( speedType ) } ;
	                                		
	                                		// Add pair
	                                		troubleSpots.addElement( triplet ) ;
	                                		
	                                		// Get Exit Name of next (which is on same line)
	                                		int menuItemIdx ;
	                                		if( (menuItemIdx = line.indexOf( exitPattern, openBracketIdx ) ) != -1 ) {
	                                			int endOfExitNameIdx = line.indexOf( "<", menuItemIdx ) ;
	                                			exitName = line.substring( menuItemIdx + exitPattern.length() + 1, endOfExitNameIdx ) ;
	                                		}
                                		}
                                		else {
	                                		// Get Exit Name of next (which is on same line)
                                    		int openBracketIdx = line.indexOf( "<", closeBracketIdx ) ;
	                                		int menuItemIdx ;
	                                		if( (menuItemIdx = line.indexOf( exitPattern, openBracketIdx ) ) != -1 ) {
	                                			int endOfExitNameIdx = line.indexOf( "<", menuItemIdx ) ;
	                                			exitName = line.substring( menuItemIdx + exitPattern.length() + 1, endOfExitNameIdx ) ;
	                                		}
                                		}
                                	}
                                }
                                
                                // <TR><TD class=menuitem>Mission Ave WB<BR></TD>
                                // <TD class=green>65 mph</TD></TR><TR><TD class=menuitem>Oceanside Blvd<BR></TD>
                               
                                buffer = new StringBuffer() ;
                            }
                            

                        }    	
                    }

                    buffer = new StringBuffer() ;
                }
            }

            connection.close() ;
        }
        catch( Exception error ) {
            
            Alert alert = new Alert( "Error", error.toString(), null, null ) ;
            alert.setTimeout( Alert.FOREVER ) ;
            alert.setType( AlertType.ERROR ) ;
            display.setCurrent( alert ) ;
            
            return null ;
        }
		
		return troubleSpots ;		
	}
}

class MyCanvas extends Canvas implements CommandListener {
	private Command back ;
	private Command exit ;

	private SDTraffic trafficCheck ;
	private int x ;
	private int y ;
	
	private int imageX = -275 ;
	private int imageY = -292 ;
	
	private int moveIncrement = 30 ;
	
	private int imageAlignV = Graphics.TOP ;
	//private int imageAlignH = Graphics.HCENTER ;
	private int imageAlignH = Graphics.LEFT ;
	
	private Image trafficImage ;
	private String errorMsg = "" ;
	
	public MyCanvas( SDTraffic trafficCheck, Image image, String errorMsg ) {
		
		this.errorMsg = errorMsg ;
		
//		imageX = 0 ;
//		imageY = getWidth() / 2 ;
		
		x = 5 ;
		y = 5 ;
		
		trafficImage = image ;
		
		this.trafficCheck = trafficCheck ;
		exit = new Command( "Exit", Command.EXIT, 1 ) ;
		back = new Command( "Back", Command.SCREEN, 1 ) ;
		
		addCommand( exit ) ;
		addCommand( back ) ;
		setCommandListener( this ) ;
	}
	
	protected void paint(Graphics graphics) {
		// Clear screen to white
		graphics.setColor( 255, 255, 255 ) ;
		graphics.fillRect( 0, 0, getWidth(), getHeight() ) ;
		
		if( trafficImage != null ) {
			
			graphics.drawImage( trafficImage, imageX, imageY, imageAlignH | imageAlignV ) ;
			
		}
		else {
			graphics.drawString( "image is null", 0, 100, Graphics.TOP | Graphics.LEFT ) ;			
		}
		
		graphics.setColor( 0, 0, 255 ) ;
		graphics.setFont( Font.getFont( Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL ) ) ;
		graphics.drawString( errorMsg, 0, 100, Graphics.TOP | Graphics.LEFT ) ;
	}

	public void commandAction(Command command, Displayable displayable ) {
		if( command == exit ) {
			trafficCheck.exitMIDlet() ;
		}
		else if( command == back ) {
			trafficCheck.showMenu() ;
		}
	}
	
	protected void keyRepeated(int keyCode) {
		keyPressed( keyCode ) ;
	}
	
	protected void keyPressed( int keyCode ) {
		switch( getGameAction( keyCode ) ) {
		case Canvas.UP:		
			imageY += moveIncrement ;
			break ;
		case Canvas.DOWN:
			imageY -= moveIncrement ;
			break ;
		case Canvas.LEFT:
			imageX += moveIncrement ;
			break ;
		case Canvas.RIGHT:
			imageX -= moveIncrement ;
			break ;
		case Canvas.FIRE:
			// Do nothing
			break ;
		}
	
		repaint() ;
	}
}